//
//  Enregistrement.m
//  DessinCommentaire
//
//  Created by Laurent Chno on Sat Apr 27 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "Enregistrement.h"


@implementation Enregistrement

- (id) initWithComment: (NSString *) comment
		  path: (NSBezierPath *) path
	   couleurFond: (NSColor *) cfond
	  couleurTraits: (NSColor *) ctrait
{
    if (self = [super init]) {
	commentaire = [comment retain];
	chemin = [path retain];
	couleurFond = [cfond retain];
	couleurTraits = [ctrait retain];
    }
    return self;
}

- (void) encodeWithCoder: (NSCoder *) coder
{
    [coder encodeObject: commentaire];
    [coder encodeObject: chemin];
    [coder encodeObject: couleurFond];
    [coder encodeObject: couleurTraits];
}

- (id) initWithCoder: (NSCoder *) coder
{
    [commentaire release];
    commentaire = [[coder decodeObject] retain];
    [chemin release];
    chemin = [[coder decodeObject] retain];
    [couleurFond release];
    couleurFond = [[coder decodeObject] retain];
    [couleurTraits release];
    couleurTraits = [[coder decodeObject] retain];
    return self;
}

- (void) dealloc
{
    [chemin release];
    [commentaire release];
    [couleurFond release];
    [couleurTraits release];
}

- (NSColor *) couleurFond
{ return couleurFond; }

- (NSColor *) couleurTraits
{ return couleurTraits; }

- (void) setCouleurFond: (NSColor *) couleur
{
    [couleurFond release];
    couleurFond = [couleur retain];
}

- (void) setCouleurTraits: (NSColor *) couleur
{
    [couleurTraits release];
    couleurTraits = [couleur retain];
}

- (NSString *) commentaire
{ return commentaire; }

- (NSBezierPath *) chemin
{ return chemin;}

@end
