//
//  MaVue.m
//  DessinCommentaire
//
//  Created by Laurent Chno on Fri Apr 26 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "MaVue.h"


@implementation MaVue

- (NSBezierPath *) chemin
{
    return chemin;
}

- (void) setPath: (NSBezierPath *) path
{
    [chemin release];
    chemin = [path retain];
    dejaClique = NO;
    segment = nil;
}

- (BOOL) isOpaque
{ return YES; }

- (NSColor *) couleurFond
{ return couleurFond; }

- (NSColor *) couleurTraits
{ return couleurTraits; }

- (void) setCouleurFond: (NSColor *) couleur
{
    [couleurFond autorelease];
    couleurFond = [couleur retain];
    [self setNeedsDisplay: YES];
}

- (void) setCouleurTraits: (NSColor *) couleur
{
    [couleurTraits autorelease];
    couleurTraits = [couleur retain];
    [self setNeedsDisplay: YES];
}

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
	chemin = [NSBezierPath bezierPath];
	segment = nil;
	couleurFond = [[NSColor whiteColor] retain];
	couleurTraits = [[NSColor blackColor] retain];
	[chemin retain];
	dejaClique = NO;
    }
    return self;
}

- (void) dealloc
{
    if (segment) [segment release];
    [chemin release];
    [super dealloc];
}

- (void)drawRect:(NSRect)rect
{
    // Drawing code here.
    [[self couleurFond] set];
    NSRectFill(rect);
    [[self couleurTraits] set];
    [chemin stroke];
    [segment stroke];
}

- (void) draw
{
    [self drawRect: [self bounds]];
}

- (IBAction) effaceTout: (id) sender
{
    [chemin release];
    chemin = [[NSBezierPath bezierPath] retain];
    dejaClique = NO;
    [self setNeedsDisplay: YES];
}

- (void) mouseUp: (NSEvent *) event
{
    NSPoint p = [self convertPoint:[event locationInWindow] fromView: nil];
    [[self superview] autoscroll: event];
    if (dejaClique) {
	[chemin lineToPoint: p];
	[[NSNotificationCenter defaultCenter] postNotificationName: @"Changement" object: nil];
    } else {
	[chemin moveToPoint: p];
    }
    dejaClique = YES;
    dernierClic = p;
    if (segment) [segment release];
    segment = nil;
    [self setNeedsDisplay: YES];
}

- (void) mouseDragged: (NSEvent *) event
{
    NSPoint p = [self convertPoint:[event locationInWindow] fromView: nil];

    if (segment) [segment release];
    segment = [[NSBezierPath bezierPath] retain];
    [[self superview] autoscroll: event];
    if (dejaClique) {
	[segment moveToPoint: dernierClic];
	[segment lineToPoint: p];
    }
    [self setNeedsDisplay: YES];
}

@end
