#import "Calculateur.h"
#import <CoreServices/CoreServices.h>

@implementation Calculateur

- (void) remplaceX: (float) a
{
    [x setFloatValue: a];
}

- (void) combineXY: (float) a
{
    [x setFloatValue: a];
    [y setFloatValue: [z floatValue]];
    [z setFloatValue: [t floatValue]];
}

- (IBAction) acos: (id) sender
{
    [self remplaceX: (acos([x floatValue]))];
}

- (IBAction) asin: (id) sender
{
    [self remplaceX: (asin([x floatValue]))];
}

- (IBAction) atan: (id) sender
{
    [self remplaceX: (atan([x floatValue]))];
}

- (IBAction) chs: (id) sender
{
    [self remplaceX: (- [x floatValue])];
}

- (IBAction) clear: (id) sender
{
    [x setFloatValue: 0.0];
    [y setFloatValue: 0.0];
    [z setFloatValue: 0.0];
    [t setFloatValue: 0.0];
}

- (IBAction) clearx: (id) sender
{
    [self remplaceX: 0.0];
}

- (IBAction) cos: (id) sender
{
    [self remplaceX: (cos([x floatValue]))];
}

- (IBAction) divise: (id) sender
{
    float vx, vy;
    vx = [x floatValue];
    vy = [y floatValue];
    [self combineXY: (vy / vx)];
}

- (IBAction) dup: (id) sender
{
    float vx;
    vx = [x floatValue];
    [self nouvelx: vx];
}

- (IBAction) exp: (id) sender
{
    [self remplaceX: (exp([x floatValue]))];
}

- (IBAction) inverse: (id) sender
{
    [self remplaceX: (1.0 / [x floatValue])];
}

- (IBAction) ln: (id) sender
{
    [self remplaceX: (log([x floatValue]))];
}

- (IBAction) moins: (id) sender
{
    float vx, vy;
    vx = [x floatValue];
    vy = [y floatValue];
    [self combineXY: (vy - vx)];
}

- (IBAction) multiplie: (id) sender
{
    float vx, vy;
    vx = [x floatValue];
    vy = [y floatValue];
    [self combineXY: (vy * vx)];
}

- (IBAction) nouvelx: (float) a
{
    [t setFloatValue: [z floatValue]];
    [z setFloatValue: [y floatValue]];
    [y setFloatValue: [x floatValue]];
    [x setFloatValue: a];
}

- (IBAction) plus: (id) sender
{
    float vx, vy;
    vx = [x floatValue];
    vy = [y floatValue];
    [self combineXY: (vy + vx)];
}

- (IBAction) puissance: (id) sender
{
    float vx, vy;
    vx = [x floatValue];
    vy = [y floatValue];
    [self combineXY: (pow(vy, vx))];
}

- (IBAction) rot: (id) sender
{
    float vx, vy, vz, vt;
    vx = [x floatValue];
    vy = [y floatValue];
    vz = [z floatValue];
    vt = [t floatValue];
    [x setFloatValue: vy];
    [y setFloatValue: vz];
    [z setFloatValue: vt];
    [t setFloatValue: vx];
}

- (IBAction) sin: (id) sender
{
    [self remplaceX: (sin([x floatValue]))];
}

- (IBAction) sqrt: (id) sender
{
    [self remplaceX: (sqrt([x floatValue]))];
}

- (IBAction) swap: (id) sender
{
    float vx, vy;
    vx = [x floatValue];
    vy = [y floatValue];
    [x setFloatValue: vy];
    [y setFloatValue: vx];
}

- (IBAction) tan: (id) sender
{
    [self remplaceX: (tan([x floatValue]))];
}

@end
