//
//  MyDocument.m
//  DessinCommentaire
//
//  Created by Laurent Chno on Fri Apr 26 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "MyDocument.h"
#import "MaVue.h"
#import "Enregistrement.h"

@implementation MyDocument

- (id) init
{
    if (self = [super init]) {
	enregistrement = [[[Enregistrement alloc] initWithComment: @"" andPath: nil] retain];
    }
    [[NSNotificationCenter defaultCenter]
	addObserver: self
	   selector: @selector(gereChangement:)
	       name: @"Changement"
	     object: nil];
    [[NSNotificationCenter defaultCenter]
	addObserver: self
	   selector: @selector(gereChangement:)
	       name: NSTextDidChangeNotification
	     object: commentaire];
				
    return self;
}

- (void) dealloc
{
    [enregistrement release];
    [[NSNotificationCenter defaultCenter] removeObserver: self];
    [super dealloc];
}

- (void) gereChangement: (NSNotification *) note
{
    [self updateChangeCount: NSChangeDone];
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    NSBezierPath *chemin;
    
    [super windowControllerDidLoadNib:aController];
    // Add any code here that need to be executed once the windowController has loaded the document's window.
    [commentaire setString: [enregistrement commentaire]];
    if (chemin = [enregistrement chemin]) {
	[vue setPath: chemin];
	[vue setNeedsDisplay: YES];
    }
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    [enregistrement release];
    enregistrement = [[[Enregistrement alloc] initWithComment: [commentaire string] andPath: [vue chemin]] retain];
    return [NSArchiver archivedDataWithRootObject: enregistrement];
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    [enregistrement release];
    enregistrement = [[NSUnarchiver unarchiveObjectWithData: data] retain];
    NSLog(@"Enregistrement lu: commentaire = %@\n et chemin = %@\n", [enregistrement commentaire], [enregistrement chemin]);
    return YES;
}

@end
